## nitrokey-authenticator 1.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
set(NITROKEY_AUTHENTICATOR_VERSION "1.2.1")

project(NitrokeyAuthenticator LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Qt5 COMPONENTS DBus Core Widgets LinguistTools Test REQUIRED)
find_package(Boost COMPONENTS log REQUIRED)
add_compile_definitions(BOOST_LOG_DYN_LINK)
find_package(PkgConfig)
pkg_search_module(HIDAPI_LIBUSB REQUIRED hidapi-libusb)
pkg_search_module(ZBARQT REQUIRED zbar-qt)

configure_file(src/applicationglobal.h.in applicationglobal.h)
configure_file(src/NitrokeyAuthenticator.desktop.in NitrokeyAuthenticator.desktop)
option(PACKAGE_TESTS "Build the tests" OFF)
if(PACKAGE_TESTS)
    include(CTest)
    enable_testing()
    include(GoogleTest)
    add_subdirectory(test)
endif()

option(USE_BUNDLED_LIBNITROKEY "Build using bundled libnitrokey, instead of the one installed system-wide" ON)

if(USE_BUNDLED_LIBNITROKEY)
    add_subdirectory (libnitrokey)
    include_directories(libnitrokey)
else()
    pkg_search_module(LIBNITROKEY REQUIRED libnitrokey-1)
endif()

set(TS_FILES src/NitrokeyAuthenticator_pl_PL.ts)

set(NitrokeyAuthenticator_src
    src/aboutnitrokeydialog.cpp
    src/aboutnitrokeydialog.h
    src/aboutnitrokeydialog.ui
    src/authentication.cpp
    src/authentication.h
    src/authenticationexception.cpp
    src/authenticationexception.h
    src/authenticatedialog.cpp
    src/authenticatedialog.h
    src/authenticatedialog.ui
    src/connectionstate.cpp
    src/connectionstate.h
    src/gettotpcoderesponse.h
    src/keytotpmodel.cpp
    src/keytotpmodel.h
    src/nitrokeybase.cpp
    src/nitrokeybase.h
    src/nitrokeyimpl.cpp
    src/nitrokeyimpl.h
    src/nitrokeyprovider.cpp
    src/nitrokeyprovider.h
    src/main.cpp
    src/mainwindow.cpp
    src/mainwindow.h
    src/mainwindow.ui
    src/newtotpslotdialog.cpp
    src/newtotpslotdialog.h
    src/newtotpslotdialog.ui
    src/newtotpslotprovider.cpp
    src/newtotpslotprovider.h
    src/totpuriparser.cpp
    src/totpuriparser.h
    src/totpslot.h
    src/totpconverter.h
    src/totpconverter.cpp
    src/randompasswordgenerator.h
    src/randompasswordgenerator.cpp
    src/screenshotter.cpp
    src/screenshotter.h
    src/unauthenticatedexception.cpp
    src/unauthenticatedexception.h
    src/waylandscreenshotexception.cpp
    src/waylandscreenshotexception.h
    src/newtotpslotprovider.h
    src/newtotpslotprovider.cpp
    src/noemptyslotexception.h
    src/noemptyslotexception.cpp
    src/duplicateslotexception.h
    src/duplicateslotexception.cpp

    resources.qrc
)
if(ANDROID)
  add_library(NitrokeyAuthenticator SHARED
    ${NitrokeyAuthenticator_src}
    ${TS_FILES}
  )
else()
  add_executable(NitrokeyAuthenticator
      ${NitrokeyAuthenticator_src}
    ${TS_FILES}
  )
endif()

include_directories(${CMAKE_BINARY_DIR})
target_include_directories(NitrokeyAuthenticator PUBLIC ${LIB_NITROKEY_INCLUDE_PATH})
target_link_libraries(NitrokeyAuthenticator Qt5::DBus Qt5::Widgets)
if(USE_BUNDLED_LIBNITROKEY)
    target_link_libraries(NitrokeyAuthenticator nitrokey)
else()
    target_compile_options(NitrokeyAuthenticator PRIVATE ${LIBNITROKEY_CFLAGS})
    target_link_libraries(NitrokeyAuthenticator ${LIBNITROKEY_LDFLAGS})
endif()
target_compile_options(NitrokeyAuthenticator PRIVATE ${HIDAPI_LIBUSB_CFLAGS})
target_link_libraries(NitrokeyAuthenticator ${HIDAPI_LIBUSB_LDFLAGS})
target_compile_options(NitrokeyAuthenticator PRIVATE ${ZBARQT_CFLAGS})
target_link_libraries(NitrokeyAuthenticator ${ZBARQT_LDFLAGS})
target_link_libraries(NitrokeyAuthenticator ${Boost_LIBRARIES})

# Installing
install(TARGETS NitrokeyAuthenticator DESTINATION bin)
install(FILES ${CMAKE_BINARY_DIR}/NitrokeyAuthenticator.desktop
    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
install(FILES ${CMAKE_SOURCE_DIR}/data/nitrokey-authenticator.appdata.xml
    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/metainfo/)
install(DIRECTORY 3rd_party/icons/
    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons
)

=== debian/changelog ===
nitrokey-authenticator (1.2.1-1build1) hirsute; urgency=medium

  * No change rebuild with fixed ownership.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2021 17:00:34 +0000

nitrokey-authenticator (1.2.1-1) unstable; urgency=high

  * New upstream release (fixes in AppStream file).
  * Bumped Standards Version to 4.5.1

 -- Patryk Cisek <patryk@debian.org>  Tue, 09 Feb 2021 08:05:18 -0800

nitrokey-authenticator (1.2-1) unstable; urgency=medium

  * New upstream release.
  * Added copyright information regarding data/nitrokey-
    authenticator.appdata.xml to debian/copyright.

 -- Patryk Cisek <patryk@debian.org>  Fri, 05 Feb 2021 09:05:12 -0800

nitrokey-authenticator (1.1-1) unstable; urgency=medium

  * New upstream release (Closes: #973628)

 -- Patryk Cisek <patryk@debian.org>  Sat, 07 Nov 2020 16:04:52 -0800

nitrokey-authenticator (1.0-2) unstable; urgency=medium

  * Changed "Vcs-*" references in debian control, so that they point to
    Salsa repo, instead of upstream on gitlab.com.

 -- Patryk Cisek <patryk@debian.org>  Sat, 17 Oct 2020 07:29:17 -0700

nitrokey-authenticator (1.0-1) unstable; urgency=medium

  * Initial release (Closes: #971857)

 -- Patryk Cisek <patryk@debian.org>  Tue, 11 Aug 2020 09:52:40 -0700

=== debian/control ===
Source: nitrokey-authenticator
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Patryk Cisek <patryk@debian.org>
Build-Depends:
 cmake (>= 3.5),
 debhelper-compat (= 12),
 libboost-log-dev,
 libnitrokey-dev,
 libzbarqt-dev,
 pkg-config,
 qtbase5-dev,
 qttools5-dev
Standards-Version: 4.5.1
Homepage: https://gitlab.com/Prezu/nitrokeyauthenticator
Vcs-Browser: https://salsa.debian.org/patryk/nitrokeyauthenticator
Vcs-Git: https://salsa.debian.org/patryk/nitrokeyauthenticator.git

Package: nitrokey-authenticator
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: TOTP authenticator app that's using Nitrokey Pro2 and/or LibremKey
 A TOTP authenticator app similar to Google Authenticator. This app, unlike
 Google Authenticator, does not store TOTP shared secrets on the computer,
 but inside the USB key. The application supports both, Nitrokey Pro2 and
 LibremKey. For the latter, however, you need to have libnitrokey version
 3.6 or newer installed on your system.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_BUNDLED_LIBNITROKEY=OFF

## nitrokey-authenticator 1.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-set(NITROKEY_AUTHENTICATOR_VERSION "1.2.1")
+set(NITROKEY_AUTHENTICATOR_VERSION "1.2.2")
 
 project(NitrokeyAuthenticator LANGUAGES CXX)

=== test/CMakeLists.txt ===
add_subdirectory("${PROJECT_SOURCE_DIR}/googletest" "googletest")

macro(package_add_test TESTNAME)
    add_executable(${TESTNAME} ${ARGN})
    target_include_directories(${TESTNAME} PUBLIC ${CMAKE_SOURCE_DIR}/src)
    target_link_libraries(${TESTNAME} gtest gmock gtest_main)
    set_target_properties(${TESTNAME} PROPERTIES FOLDER tests)
endmacro()

macro(add_to_ctest TESTNAME)
    gtest_discover_tests(${TESTNAME}
        # set a working directory so your project root so that you can find test data via paths relative to the project root
        WORKING_DIRECTORY ${PROJECT_DIR}
        PROPERTIES VS_DEBUGGER_WORKING_DIRECTORY "${PROJECT_DIR}"
    )
endmacro()

#####################
# GTest/GMock tests *
#####################
set(unit_test_src
    ${CMAKE_SOURCE_DIR}/src/totpuriparser.cpp
    unit_tests/totpparsertest.cpp
    ${CMAKE_SOURCE_DIR}/src/totpconverter.cpp
    unit_tests/totpconvertertest.cpp
    ${CMAKE_SOURCE_DIR}/src/randompasswordgenerator.cpp
    unit_tests/randompasswordgeneratortest.cpp
    ${CMAKE_SOURCE_DIR}/src/newtotpslotprovider.cpp
    unit_tests/newtotpslotprovidertest.cpp
    ${CMAKE_SOURCE_DIR}/src/duplicateslotexception.cpp
    ${CMAKE_SOURCE_DIR}/src/noemptyslotexception.cpp
)

#####################
# Tests on Nitrokey #
#####################
set(no_ctest_tests_src
    ${CMAKE_SOURCE_DIR}/src/authenticationexception.cpp
    ${CMAKE_SOURCE_DIR}/src/nitrokeybase.cpp
    ${CMAKE_SOURCE_DIR}/src/nitrokeyimpl.cpp
    against_key/nitrokeyimpltest.cpp
)

#######################
# Qt-aware unit tests #
#######################
set(nitrokeyprovidertests_src
    ${CMAKE_SOURCE_DIR}/src/authenticationexception.cpp
    ${CMAKE_SOURCE_DIR}/src/nitrokeybase.cpp
    ${CMAKE_SOURCE_DIR}/src/nitrokeyprovider.cpp
    ${CMAKE_SOURCE_DIR}/src/randompasswordgenerator.cpp
    qt_specific/nitrokeyprovidertest.cpp
)

set(keytotpmodeltests_src
    ${CMAKE_SOURCE_DIR}/src/authenticatedialog.cpp
    ${CMAKE_SOURCE_DIR}/src/authentication.cpp
    ${CMAKE_SOURCE_DIR}/src/connectionstate.cpp
    ${CMAKE_SOURCE_DIR}/src/duplicateslotexception.cpp
    ${CMAKE_SOURCE_DIR}/src/nitrokeybase.cpp
    ${CMAKE_SOURCE_DIR}/src/keytotpmodel.cpp
    ${CMAKE_SOURCE_DIR}/src/nitrokeyprovider.cpp
    ${CMAKE_SOURCE_DIR}/src/newtotpslotdialog.cpp
    ${CMAKE_SOURCE_DIR}/src/newtotpslotprovider.cpp
    ${CMAKE_SOURCE_DIR}/src/noemptyslotexception.cpp
    ${CMAKE_SOURCE_DIR}/src/randompasswordgenerator.cpp
    ${CMAKE_SOURCE_DIR}/src/totpconverter.cpp
    ${CMAKE_SOURCE_DIR}/src/totpuriparser.cpp
    ${CMAKE_SOURCE_DIR}/src/unauthenticatedexception.cpp
    qt_specific/keytotpmodeltest.cpp
)

set(authenticationtests_src
    ${CMAKE_SOURCE_DIR}/src/authenticatedialog.cpp
    ${CMAKE_SOURCE_DIR}/src/authenticationexception.cpp
    ${CMAKE_SOURCE_DIR}/src/authentication.cpp
    ${CMAKE_SOURCE_DIR}/src/nitrokeybase.cpp
    ${CMAKE_SOURCE_DIR}/src/nitrokeyprovider.cpp
    ${CMAKE_SOURCE_DIR}/src/randompasswordgenerator.cpp
    ${CMAKE_SOURCE_DIR}/src/unauthenticatedexception.cpp
    qt_specific/authenticationtest.cpp
)

set(connectionstatetests_src
    ${CMAKE_SOURCE_DIR}/src/connectionstate.cpp
    qt_specific/connectionstatetest.cpp
)

# Common unit tests using GoogleTest and GoogleMock
package_add_test(tests ${unit_test_src})
add_to_ctest(tests)
target_link_libraries(tests
    ${Boost_LIBRARIES}
    Qt5::Widgets
)

# Tests that operate on actual key, so they cannot be included
# in main ctest run. Thus, no call to "add_to_ctest" macro for this
# target.
package_add_test(dont_add_to_ctest ${no_ctest_tests_src})
target_link_libraries(dont_add_to_ctest
    ${Boost_LIBRARIES}
    ${HIDAPI_LIBUSB_LDFLAGS} nitrokey
    Qt5::Widgets
)

# Unit tests using QTest -- those tests involve testing
# Qt-specific functionality, like signals and slots. They
# are part of main ctest run.
# Each test case requires a separate test executable.
macro(add_qt_specific_tests TEST_TARGET_NAME TEST_SRCS)
    add_executable(${TEST_TARGET_NAME} ${TEST_SRCS})
    target_include_directories(${TEST_TARGET_NAME} PUBLIC ${CMAKE_SOURCE_DIR}/src)
    target_link_libraries(${TEST_TARGET_NAME}
        gtest gmock
        Qt5::Widgets
        Qt5::Test
        ${Boost_LIBRARIES}
    )
    add_test(NAME ${TEST_TARGET_NAME} COMMAND ${TEST_TARGET_NAME} --platform minimal)
endmacro()

add_qt_specific_tests(nitrokeyprovidertests "${nitrokeyprovidertests_src}")
add_qt_specific_tests(keytotpmodeltests "${keytotpmodeltests_src}")
add_qt_specific_tests(authenticationtests "${authenticationtests_src}")
add_qt_specific_tests(connectionstatetests "${connectionstatetests_src}")

=== debian/changelog ===
nitrokey-authenticator (1.2.2-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Patryk Cisek <patryk@debian.org>  Thu, 09 Sep 2021 14:24:34 -0700

nitrokey-authenticator (1.2.2-1) unstable; urgency=medium

  * New upstream release.
  * Added debian/gbp.conf.
  * Added copyright info for release_checklist.txt to debian/copyright.

 -- Patryk Cisek <patryk@debian.org>  Thu, 09 Sep 2021 13:09:13 -0700

nitrokey-authenticator (1.2.1-2) unstable; urgency=medium

  * Eliminated false-positive reported by blhc.

 -- Patryk Cisek <patryk@debian.org>  Thu, 19 Aug 2021 17:08:42 -0700

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: nitrokey-authenticator
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Patryk Cisek <patryk@debian.org>
+Maintainer: Patryk Cisek <patryk@debian.org>
 Build-Depends:
  cmake (>= 3.5),
  debhelper-compat (= 12),

## nitrokey-authenticator 1.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-set(NITROKEY_AUTHENTICATOR_VERSION "1.2.2")
+set(NITROKEY_AUTHENTICATOR_VERSION "1.2.3")
 
 project(NitrokeyAuthenticator LANGUAGES CXX)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -103,6 +103,9 @@
     ${HIDAPI_LIBUSB_LDFLAGS} nitrokey
     Qt5::Widgets
 )
+if(USE_BUNDLED_LIBNITROKEY)
+	target_include_directories(dont_add_to_ctest PUBLIC ${CMAKE_SOURCE_DIR}/libnitrokey)
+endif(USE_BUNDLED_LIBNITROKEY)
 
 # Unit tests using QTest -- those tests involve testing
 # Qt-specific functionality, like signals and slots. They

=== debian/changelog ===
nitrokey-authenticator (1.2.3-1) unstable; urgency=medium

  * New upstream release.

 -- Patryk Cisek <patryk@debian.org>  Mon, 07 Feb 2022 10:57:37 -0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Patryk Cisek <patryk@debian.org>
 Build-Depends:
- cmake (>= 3.5),
+ cmake,
  debhelper-compat (= 12),
  libboost-log-dev,
  libnitrokey-dev,

=== debian/rules ===
--- 
+++ 
@@ -9,5 +9,6 @@
 	dh $@
 
 override_dh_auto_configure:
+	@echo "blhc: ignore-line-regexp: .*CMakeCXXCompilerABI\.cpp.*"
 	dh_auto_configure -- -DUSE_BUNDLED_LIBNITROKEY=OFF

## nitrokey-authenticator 1.2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-set(NITROKEY_AUTHENTICATOR_VERSION "1.2.3")
+set(NITROKEY_AUTHENTICATOR_VERSION "1.2.4")
 
 project(NitrokeyAuthenticator LANGUAGES CXX)

=== debian/changelog ===
nitrokey-authenticator (1.2.4-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:08:04 +1100

nitrokey-authenticator (1.2.4-2build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:03:56 +0000

nitrokey-authenticator (1.2.4-2build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:53:02 +0100

nitrokey-authenticator (1.2.4-2) unstable; urgency=medium

  * Updated the link to homepage in debian/control.

 -- Patryk Cisek <patryk@debian.org>  Thu, 08 Sep 2022 16:28:24 -0700

nitrokey-authenticator (1.2.4-1) unstable; urgency=medium

  * New upstream release.

 -- Patryk Cisek <patryk@debian.org>  Wed, 31 Aug 2022 09:55:33 -0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: nitrokey-authenticator
 Section: utils
 Priority: optional
-Maintainer: Patryk Cisek <patryk@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Patryk Cisek <patryk@debian.org>
 Build-Depends:
  cmake,
  debhelper-compat (= 12),
@@ -12,7 +13,7 @@
  qtbase5-dev,
  qttools5-dev
 Standards-Version: 4.5.1
-Homepage: https://gitlab.com/Prezu/nitrokeyauthenticator
+Homepage: https://gitlab.com/prezu-debian/nitrokeyauthenticator
 Vcs-Browser: https://salsa.debian.org/patryk/nitrokeyauthenticator
 Vcs-Git: https://salsa.debian.org/patryk/nitrokeyauthenticator.git
